import arcpy
import os
import pandas as pd
import numpy as np
import string
import random
import zipfile



gdb = arcpy.GetParameterAsText(0)
carpeta_salida=arcpy.GetParameterAsText(1)


arcpy.env.workspace = gdb
listfeatures=arcpy.ListFeatureClasses()

dsList = arcpy.ListDatasets("*", feature_type="Feature")
dsList.sort()

for ds in dsList:
    carpeta_shapes=os.path.join(carpeta_salida, ds)
    if not os.path.isdir(carpeta_shapes):
        os.mkdir(carpeta_shapes)

    fcList = arcpy.ListFeatureClasses("*", feature_type="ALL", feature_dataset=ds)
    for fc in fcList:

        arcpy.FeatureClassToFeatureClass_conversion(fc, carpeta_shapes,
                                        fc)

        fields = arcpy.ListFields(fc)
        for field in fields:
            if field.length>250:
                with arcpy.da.UpdateCursor(fc,[field.name]) as cursor:
                    for row in cursor:
                        try:
                            if len(str(row[0].encode('utf-8')))>250:
                                row[0] = row[0][0:250]
                                cursor.updateRow(row)
                        except:pass



        with zipfile.ZipFile(os.path.join(carpeta_shapes, fc + '.zip'),'w') as fzip:
            for root, dirs, files in os.walk(carpeta_shapes):
                for archivo in files:
                    if not (archivo.endswith('.zip') ):
                        if fc in archivo:
                            fzip.write(os.path.join(root, archivo), os.path.relpath(os.path.join(root,archivo), root), compress_type = zipfile.ZIP_DEFLATED)
                            os.remove(os.path.join(root,archivo))


Listtb=arcpy.ListTables()

for tb in Listtb:
    fields = arcpy.ListFields(tb)
    for field in fields:
        if field.length>250:
            with arcpy.da.UpdateCursor(tb,[field.name]) as cursor:
                for row in cursor:
                    try:
                        if len(str(row[0].encode('utf-8')))>250:
                            row[0] = row[0][0:250]
                            cursor.updateRow(row)
                    except:pass

    arcpy.conversion.TableToTable(tb, carpeta_salida,tb)

    with zipfile.ZipFile(os.path.join(carpeta_salida, tb + '.zip'),'w') as fzip:
        for root, dirs, files in os.walk(carpeta_salida):
            for archivo in files:
                if not (archivo.endswith('.zip') ):
                    if tb in archivo:
                        fzip.write(os.path.join(root, archivo), os.path.relpath(os.path.join(root,archivo), root), compress_type = zipfile.ZIP_DEFLATED)
                        os.remove(os.path.join(root,archivo))


